# <img src="https://www.koozali.org/images/koozali/Logo/Png/Koozali_logo_2016.png" width="25%" vertical="auto" style="vertical-align:bottom"> smeserver-postfix

SMEServer Koozali developed git repo for smeserver-postfix core 

## Wiki
<br />https://wiki.koozali.org/smeserver-postfix

## Bugzilla
Show list of outstanding bugs:
[All](https://bugs.koozali.org/buglist.cgi?action=wrap&bug_status=UNCONFIRMED&bug_status=CONFIRMED&bug_status=NEEDINFO&bug_status=IN_PROGRESS&bug_status=RESOLVED&bug_status=VERIFIED&cf_package=smeserver-postfix&classification=SME+Server&list_id=105756&order=changeddate+DESC%2Ccomponent%2Cpriority%2Cbug_severity&query_format=advanced)  
[Confirmed](https://bugs.koozali.org/buglist.cgi?action=wrap&bug_status=CONFIRMED&cf_package=smeserver-postfix&classification=SME+Server&order=changeddate+DESC%2Ccomponent%2Cpriority%2Cbug_severity&query_format=advanced)  
[Unconfirmed](https://bugs.koozali.org/buglist.cgi?action=wrap&bug_status=UNCONFIRMED&cf_package=smeserver-postfix&classification=SME+Server&order=changeddate+DESC%2Ccomponent%2Cpriority%2Cbug_severity&query_format=advanced)  
[Need info](https://bugs.koozali.org/buglist.cgi?action=wrap&bug_status=NEEDINFO&cf_package=smeserver-postfix&classification=SME+Server&order=changeddate+DESC%2Ccomponent%2Cpriority%2Cbug_severity&query_format=advanced)  
[In progress](https://bugs.koozali.org/buglist.cgi?action=wrap&bug_status=IN_PROGRESS&cf_package=smeserver-postfix&classification=SME+Server&order=changeddate+DESC%2Ccomponent%2Cpriority%2Cbug_severity&query_format=advanced)  
[Resolved](https://bugs.koozali.org/buglist.cgi?action=wrap&bug_status=RESOLVED&cf_package=smeserver-postfix&classification=SME+Server&order=changeddate+DESC%2Ccomponent%2Cpriority%2Cbug_severity&query_format=advanced)  
[Verified](https://bugs.koozali.org/buglist.cgi?action=wrap&bug_status=VERIFIED&cf_package=smeserver-postfix&classification=SME+Server&order=changeddate+DESC%2Ccomponent%2Cpriority%2Cbug_severity&query_format=advanced)

## Description

Koozali SME Server wrapper to configure postfix

## Development and testing
```
 echo "This email confirms that Postfix is working" | mail -s "Testing Posfix" emailuser@example.com
```
or using roundcube/ mail client

DONE
* main domain
* listen only socket
* virtual alias for system, pseudonyms, groups, shared
* forward email support via .qmail
* spam filtering to .junk
* .qmail support using mini-qmail + wrapper and seakablepipe
* maildrop/procmail support directly via .qmail 
* check /usr/sbin/sendmail -> /etc/alternatives/mta -> /usr/sbin/sendmail.postfix
* EmailUnknownUser support in virtual 
* migrate and remove qmail properties to postfix
* make a copy of /var/qmail/control/smtproutes to (su)qpsmtpd/config/smtproutes

TODO
* remove from smeserver-mail /usr/local/sbin/smtp-auth-proxy.pl
* migrate and rewrite code for smtp-auth-proxy properties
* panel to list / manage queue

FUTURE
* .foward support, when/if .qmail support is dropped 
* ldap / AD user support
* throttle for some destination

TO CHECK
    $prop->{Blacklist} = $smtp_proxy_rec->prop('Blacklist') || " ";
    $prop->{Debug} = $smtp_proxy_rec->prop('Debug');

VARIABLES

domain
* domain -> EmailTo to send all emails for a domain to an email
* domain -> MailServer
* domain -> VirtualMail as default disabled, will only accepte mails to a defined pseudonym for this domain  

config 
* DelegateMailServer
* SMTPSmartHost
* postfix->MaxMessageSize defined as 15Mb
* postfix->FilterType (empty)
* postfix->ConcurrencyRemote default to 20
* postfix->ConcurrencyLocal default to 20
* postfix->DoubleBounceTo default to postmaster
* postfix->tls_security_level default to may
* postfix->tls_enforce_peername default to yes 
* $qpsmtpd{HeloHost} default to $myhostname
* smtp-auth-proxy SMTPSmartHost
* smtp-auth-proxy  Userid
* smtp-auth-proxy  Passwd
* smtp-auth-proxy  PeerPort
* EmailUnknownUser (default to returntosender)

REFERENCES
* https://serverfault.com/questions/638152/how-to-remove-postfix-queue-messages-sent-to-a-specific-domain
* https://unix.stackexchange.com/questions/93197/postfix-configuration-to-verify-all-recipients
* https://phoenixnap.com/kb/postfix-smtp
* https://www.gentei.org/~yuuji/software/dotqmail/
* https://www.gentei.org/~yuuji/software/dotqmail/dotqmail
* https://sixohthree.com/424/smtp-2 
* https://mailing.postfix.users.narkive.com/AhepT4TC/qmail-local-transport
* https://skarnet.org/software/s6-portable-utils/
* https://johnleach.co.uk/documents/qmail-to-postfix/
* https://www.mail-archive.com/search?l=tmda-users@tmda.net&q=subject:%22Slightly+OT%5C%3A+Opinions+Wanted+%5C-+Implementing+dot%5C-qmail+in+postfix%5C%3F%22&o=newest&f=1
* https://luke.skr.jp/hsj/?cmd=backup&action=nowdiff&page=OpenBlockS%2FMailServer&age=3
* https://www.postfix.org/ADDRESS_CLASS_README.html#virtual_mailbox_class
* https://www.postfix.org/VIRTUAL_README.html#virtual_mailbox
* https://www.postfix.org/ADDRESS_CLASS_README.html#virtual_alias_class 
* https://www.postfix.org/master.5.html
* https://hostadvice.com/how-to/web-hosting/vps/how-to-setup-postfix-as-send-only-mail-server-on-an-ubuntu-18-04-dedicated-server-or-vps/
* https://sscnet.ch/content/update-3-installing-qpsmtpd-bionic-beaver-ubuntu
* https://www.postfix.org/postconf.5.html#luser_relay
* https://serverfault.com/questions/960074/luser-relay-does-not-forward-the-emails
* https://serverfault.com/questions/885483/postfix-catchall-user-not-found-in-virtual-alias-table
